/*/////////////////////////////////////////////////////////////////////////
Name : Gajendra Singh
File : USB Interface Class.
Date : April 20, 2005
Description : This class is generated using MFC. 
This class is a modified version of a C-program by cypress
////////////////////////////////////////////////////////////////////////*/


#include "stdafx.h"
#include "mdb2.h"
#include "DropDialog.h"
#include <process.h>
#include <winioctl.h>
#include "ezusbsys.h"

//global variables
BOOL StopTest;
CPaintDC *viewdc = NULL;
int currval =150;
int currx = 0;
int currread = 0;
CWnd* view = NULL;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDropDialog dialog


CDropDialog::CDropDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CDropDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDropDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

   hOutputBox                      = NULL;
   hDevice                         = NULL;
   pcDriverName[MAX_DRIVER_NAME]   = '\0';
   bResult                         = FALSE;
   nBytes                          = 0;
   nItems                          = 0;
   hFont                           = NULL;
   ulLength                         = 0;



}


void CDropDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDropDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDropDialog, CDialog)
	//{{AFX_MSG_MAP(CDropDialog)
	ON_BN_CLICKED(IDC_StartIsoStream, OnStartIsoStream)
	ON_BN_CLICKED(IDC_StopIsoStream, OnStopIsoStream)
	ON_BN_CLICKED(IDC_ReadIsoBuffer, OnReadIsoBuffer)
	ON_BN_CLICKED(IDC_StartReadThread, OnStartReadThread)
	ON_BN_CLICKED(IDC_StopReadThread, OnStopReadThread)
	ON_BN_CLICKED(IDC_Quit, OnQuit)
	ON_BN_CLICKED(IDC_About, OnAbout)
	ON_BN_CLICKED(IDC_Clear, OnClear)
	ON_BN_CLICKED(IDC_Init, OnInit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDropDialog message handlers

void CDropDialog::OnStartIsoStream() 
{
	// TODO: Add your control notification handler code here
	
ISO_TRANSFER_CONTROL 	IsoControl;
         ULONG                   pipenum;
         BOOL                    Success;
         ULONG                   count=0;

      // Get a handle to the output box
      hOutputBox = GetDlgItem (IDC_Outputboxac);


         // Open the driver
         GetDlgItemText (IDC_Device, pcDriverName, MAX_DRIVER_NAME);
         if (bOpenDriver (&hDevice, pcDriverName) == TRUE)
         {
          hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"Opened Driver Successfully");
         } 
		 else 
		 {
          hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"Failed to Open Driver");
          hDevice = NULL;
			return;
         }

         IsoControl.PacketSize = GetDlgItemInt(IDC_PacketSize,&Success,FALSE);


         // reset the pipe
         pipenum = GetDlgItemInt (IDC_PipeNum, NULL, FALSE);

         bResult = DeviceIoControl (hDevice,
                     IOCTL_Ezusb_RESETPIPE,
                     &pipenum,
                     sizeof(ULONG),
                     NULL,
                     0,
                     (LPDWORD)(&nBytes),
                     NULL);

         if (bResult != TRUE)
         {
            hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"Pipe Reset Failed");
            CloseHandle (hDevice);
           return;
         }
         // perform the ISO transfer
         IsoControl.PacketCount = GetDlgItemInt(IDC_PacketCount,&Success,FALSE);
         IsoControl.PipeNum = GetDlgItemInt(IDC_PipeNum,&Success,FALSE);
         IsoControl.BufferCount = GetDlgItemInt(IDC_BufferCount,&Success,FALSE);
         IsoControl.FramesPerBuffer = GetDlgItemInt(IDC_FramesPerBuffer,&Success,FALSE);

         bResult = DeviceIoControl (hDevice,
                        IOCTL_EZUSB_START_ISO_STREAM,
                        &IsoControl,
                        sizeof(ISO_TRANSFER_CONTROL),
                        NULL,
                        0,
                        (LPDWORD)(&nBytes),
                        NULL);

         if (bResult != TRUE)
         {
            hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"ISO Transfer Failed");
            CloseHandle (hDevice);
           return;
         }

         CloseHandle (hDevice);

}

void CDropDialog::OnStopIsoStream() 
{
	// TODO: Add your control notification handler code here

         // Open the driver
         GetDlgItemText (IDC_Device, pcDriverName, MAX_DRIVER_NAME);
         if (bOpenDriver (&hDevice, pcDriverName) == TRUE)
         {
          hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"Opened Driver Successfully");
         } 
		 else 
		 {
          hOutputBox->SendMessage ( LB_ADDSTRING, 0, (LPARAM)"Failed to Open Driver");
          hDevice = NULL;
          return;
         }



         bResult = DeviceIoControl (hDevice,
                        IOCTL_EZUSB_STOP_ISO_STREAM,
                        NULL,
                        0,
                        NULL,
                        0,
                        (LPDWORD)(&nBytes),
                        NULL);

         if (bResult != TRUE)
         {
            hOutputBox->SendMessage ( LB_ADDSTRING, 0, (LPARAM)"ISO Transfer Failed");
            CloseHandle (hDevice);
            return;
         }

         CloseHandle (hDevice);

	
}

void CDropDialog::OnReadIsoBuffer() 
{
	// TODO: Add your control notification handler code here
         ISO_TRANSFER_CONTROL 	IsoControl;
         ULONG                   bytesToRead;
         BOOL                    Success;
         PUCHAR                  buffer = NULL;
         ULONG                   packetsRead;
         PUSBD_ISO_PACKET_DESCRIPTOR isoDesc;
         ULONG                   i;
         PUCHAR                  ptr;

		
         hOutputBox = GetDlgItem (IDC_Outputboxac);

         // Open the driver
         GetDlgItemText ( IDC_Device, pcDriverName, MAX_DRIVER_NAME);
         if (bOpenDriver (&hDevice, pcDriverName) == TRUE)
         {
          hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"Opened Driver Successfully");
         } 
		 else 
		 {
          hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"Failed to Open Driver");
          hDevice = NULL;
          return;
         }

         IsoControl.PacketSize = GetDlgItemInt(IDC_PacketSize,&Success,FALSE);
         IsoControl.PacketCount = GetDlgItemInt(IDC_PacketCount,&Success,FALSE);
         IsoControl.PipeNum = GetDlgItemInt(IDC_PipeNum,&Success,FALSE);
         IsoControl.BufferCount = GetDlgItemInt(IDC_BufferCount,&Success,FALSE);
         IsoControl.FramesPerBuffer = GetDlgItemInt(IDC_FramesPerBuffer,&Success,FALSE);

         bytesToRead = IsoControl.PacketCount * (IsoControl.PacketSize + sizeof(USBD_ISO_PACKET_DESCRIPTOR));
         buffer = (PUCHAR) malloc(bytesToRead);
         sprintf(tempbuff, "requesting %d bytes",bytesToRead);
         hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM) tempbuff);

         if (!buffer)
         {
            hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"alloc Failed");
            return;
         }
	      QueryPerformanceFrequency(&llnHPTimerFreq);
	      QueryPerformanceCounter(&llnHPT1);

         bResult = DeviceIoControl (hDevice,
                        IOCTL_EZUSB_READ_ISO_BUFFER,
                        &IsoControl,
                        sizeof(ISO_TRANSFER_CONTROL),
                        buffer,
                        bytesToRead,
                        (LPDWORD)(&nBytes),
                        NULL);
   	   QueryPerformanceCounter(&llnHPT2);

         llnT_uSec.QuadPart = ( (llnHPT2.QuadPart - llnHPT1.QuadPart) * // Time Delta
				                    ((LONGLONG)1E9/llnHPTimerFreq.QuadPart) ) / 
								         (LONGLONG)1E3; // could divide by 1E9 for Time in Sec
			sprintf(tempbuff,"DMA completed in %3d Sec: %03d mSec: %03d  uSec\n", 
				llnT_uSec.LowPart/(LONG)1E6, (llnT_uSec.LowPart/(LONG)1E3)%(1000), 
				(llnT_uSec.LowPart)%(1000));
         hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM) tempbuff);

         if (bResult != TRUE)
         {
            hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM)"ISO Read Failed");
            CloseHandle (hDevice);
            return;
         }



         sprintf(tempbuff, "transferred %d bytes",nBytes);
		 
         hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM) tempbuff);

         packetsRead = nBytes / (IsoControl.PacketSize + sizeof(USBD_ISO_PACKET_DESCRIPTOR));

         ptr = buffer;   
         isoDesc = (PUSBD_ISO_PACKET_DESCRIPTOR) (buffer + (packetsRead * IsoControl.PacketSize));
         for (i=0;i<packetsRead;i++)
         {
            sprintf(tempbuff, "Packet %d length = %d status = %d val = %d",i,isoDesc[i].Length,isoDesc[i].Status,*ptr);

            hOutputBox->SendMessage (LB_ADDSTRING, 0, (LPARAM) tempbuff);
            ptr++;
         }
         free(buffer);
         CloseHandle (hDevice);
	
}


void CDropDialog::OnStartReadThread() 
{
	// TODO: Add your control notification handler code here
	StopTest = FALSE;
    voidfunc = TestThread;
	_beginthread(voidfunc,0,this->m_hWnd); 

}

void CDropDialog::OnStopReadThread() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	StopTest = TRUE;
	
}

void CDropDialog::OnQuit() 
{
	// TODO: Add your control notification handler code here
	
}

void CDropDialog::OnAbout() 
{
	// TODO: Add your control notification handler code here
		     sprintf(tempbuff,"EZ-USB Isostrm - built %s %s",build_time,build_date);
         MessageBox(tempbuff,"About EZ-USB",MB_ICONINFORMATION);

}

void CDropDialog::OnClear() 
{
	// TODO: Add your control notification handler code here
         hOutputBox = GetDlgItem (IDC_Outputboxac);
         hOutputBox->SendMessage (LB_RESETCONTENT, 0, 0);


	
}

BOOL CDropDialog::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class	
	return CDialog::PreCreateWindow(cs);
}

void CDropDialog::OnInit() 
{
	// TODO: Add your control notification handler code here

	CClientDC dc(this);

	//CDHtmlDialog::OnInitDialog();

	build_time = __TIME__;
	build_date = __DATE__;

      // Get a handle to the output box
      hOutputBox = GetDlgItem (IDC_Outputboxac);
      
      // Setup the std system font
      sprintf(tempbuff,"EZ-USB Isostrm - built %s %s",build_time,build_date);
      hOutputBox->SendMessage(LB_ADDSTRING, 0, (LPARAM)tempbuff); 
      
      // Setup the default symbolic name for the device driver           
      SetDlgItemText (IDC_Device, "Ezusb-0");

      SetDlgItemInt(IDC_PipeNum,0,FALSE);
      SetDlgItemInt(IDC_PacketCount,128,FALSE);
      SetDlgItemInt(IDC_PacketSize,64,FALSE);
      SetDlgItemInt(IDC_BufferCount,2,FALSE);
      SetDlgItemInt(IDC_FramesPerBuffer,8,FALSE);
      
	
}


void TestThread(
  void* lpParameter   // thread data
)
{
   HWND hDlg = (HWND) lpParameter;
   HWND    hOutputBox                      = NULL;
   HANDLE  hDevice                         = NULL;
   char    pcDriverName[MAX_DRIVER_NAME]   = "";
   BOOLEAN bResult                         = FALSE;
   int     nBytes                          = 0;
   int     nItems                          = 0;
   ISO_TRANSFER_CONTROL 	IsoControl;
   ULONG                   bytesToRead;
   BOOL                    Success;
   PUCHAR                  buffer = NULL;
   ULONG                   packetsRead;
   PUSBD_ISO_PACKET_DESCRIPTOR isoDesc;
   ULONG                   i;
   PUCHAR                  ptr;
   ULONG                   pass = 0;
   UCHAR                   count = 0;
   ULONG                   framesRead = 0;
   ULONG                   framesMissed = 0;
   char    tempbuff[256];
    
      // Get a handle to the output box
   hOutputBox = GetDlgItem (hDlg, IDC_Outputboxac);

   // Open the driver
   GetDlgItemText (hDlg, IDC_Device, pcDriverName, MAX_DRIVER_NAME);
   if (bOpenDriver (&hDevice, pcDriverName) == TRUE)
   {
    SendMessage (hOutputBox, LB_ADDSTRING, 0, (LPARAM)"Opened Driver Successfully");
   } else {
    SendMessage (hOutputBox, LB_ADDSTRING, 0, (LPARAM)"Failed to Open Driver");
    hDevice = NULL;
    return;
   }

   IsoControl.PacketSize = GetDlgItemInt(hDlg, IDC_PacketSize,&Success,FALSE);
   IsoControl.PacketCount = GetDlgItemInt(hDlg, IDC_PacketCount,&Success,FALSE);
   IsoControl.PipeNum = GetDlgItemInt(hDlg, IDC_PipeNum,&Success,FALSE);
   IsoControl.BufferCount = GetDlgItemInt(hDlg, IDC_BufferCount,&Success,FALSE);
   IsoControl.FramesPerBuffer = GetDlgItemInt(hDlg, IDC_FramesPerBuffer,&Success,FALSE);

   bytesToRead = IsoControl.PacketCount * (IsoControl.PacketSize + sizeof(USBD_ISO_PACKET_DESCRIPTOR));
   buffer = (PUCHAR) malloc(bytesToRead);
   if (!buffer)
   {
      SendMessage (hOutputBox, LB_ADDSTRING, 0, (LPARAM)"alloc Failed");
      CloseHandle(hDevice);
      return;
   }

   while (!StopTest)
   {
      bResult = DeviceIoControl (hDevice,
                     IOCTL_EZUSB_READ_ISO_BUFFER,
                     &IsoControl,
                     sizeof(ISO_TRANSFER_CONTROL),
                     buffer,
                     bytesToRead,
                     (LPDWORD)(&nBytes),
                     NULL);

      if (bResult != TRUE)
      {
         SendMessage (hOutputBox, LB_ADDSTRING, 0, (LPARAM)"Read ISO Buffer Failed");
         break;
      }

      packetsRead = nBytes / (IsoControl.PacketSize + sizeof(USBD_ISO_PACKET_DESCRIPTOR));

      ptr = buffer;
      isoDesc = (PUSBD_ISO_PACKET_DESCRIPTOR) (buffer + (packetsRead * IsoControl.PacketSize));
      for (i=0;i<packetsRead;i++)
      {
         framesRead++;
         if (!(framesRead % 1000))         {
            SetDlgItemInt(hDlg, IDC_FramesRead,framesRead/1000,FALSE);
         }
         
         if (count != *ptr)
         {
            framesMissed++;
            SetDlgItemInt(hDlg, IDC_FramesMissed,framesMissed,FALSE);
            sprintf(tempbuff, "Missed frame = 0x%x",count);
            SendMessage (hOutputBox, LB_ADDSTRING, 0, (LPARAM) tempbuff);
            DumpBuffer(ptr,isoDesc[i].Length,hOutputBox);
            count = *ptr;
         }

         count++;

         if (isoDesc[i].Length != IsoControl.PacketSize)
         {
            framesMissed++;
            SetDlgItemInt(hDlg, IDC_FramesMissed,framesMissed,FALSE);
            sprintf(tempbuff, "Short Packet received");
            SendMessage (hOutputBox, LB_ADDSTRING, 0, (LPARAM) tempbuff);
         }
		 
			currread = (currread + 1)%100;

			if(currread == 0)
			{
			currval = *(ptr+2);
			currx = (currx + 1)%700;
			if(currx == 0)
				view->InvalidateRect ( NULL, TRUE);
			else
				view->InvalidateRect ( NULL, FALSE);
			view->UpdateWindow();
			}			
			ptr += IsoControl.PacketSize;
         
      }

   }
   
   CloseHandle (hDevice);
   free(buffer);
 }


void
DumpBuffer(PVOID pvBuffer, ULONG length, HWND hOutputBox)
{
   int                    nItems    = 0;
   char                   temp[64]  = "";
   char                   temp2[64]  = "";
   ULONG	i;
   ULONG   j;
   PUCHAR	ptr;
   
   MAINTAIN_OUTPUT_BOX (hOutputBox, nItems);
   
   ptr = (PUCHAR) pvBuffer;
   
   for (i = 0; i < ((length + BYTES_PER_LINE - 1) / BYTES_PER_LINE); i++)
   {
      wsprintf(temp,"%04X ",(i*BYTES_PER_LINE));
      for (j = 0; j < BYTES_PER_LINE; j++)
      {
         if (((i * BYTES_PER_LINE) + j) < length)
         {
            wsprintf(temp2,"%02X ",*ptr++);
            strcat(temp,temp2);
         }
      }
      SendMessage (hOutputBox, LB_ADDSTRING, 0, (LPARAM)temp);
   }
}


/**************************************************
* bOpenDriver proc                               *
*                                                *
* Purpose:                                       *  
*      Opens the device driver using symbolic    *
*      name provided                             *
*                                                *
* Input:                                         *
*      phDeviceHandle:                           *
*          Pointer to Device Driver handle where *
*          the file handle is placed.            *
*      devname:                                  *
*          Null terminated string containing the *
*          device name                           *
*                                                *
* Return Value:                                  *
*      Boolean that indicates if the driver was  *
*      successfully opened or not.               *
*                                                *
**************************************************/

bool bOpenDriver (HANDLE * phDeviceHandle, PCHAR devname)
{
   char completeDeviceName[64] = "";
   char pcMsg[64] = "";
   
   strcat (completeDeviceName,
      "\\\\.\\"
      );
   
   strcat (completeDeviceName,
		    devname
          );
   
   *phDeviceHandle = CreateFile(   completeDeviceName,
      GENERIC_WRITE,
      FILE_SHARE_WRITE,
      NULL,
      OPEN_EXISTING,
      0,
      NULL);
   
   if (*phDeviceHandle == INVALID_HANDLE_VALUE) {
      return (FALSE);
   } else {
      return (TRUE);
   } /*else*/
   
   
}//OpenDevice


